# coding: utf-8

"""
    Gate API v4

    Welcome to Gate API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.   # noqa: E501

    Contact: support@mail.gate.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class AgencyCommission(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'commission_time': 'int',
        'user_id': 'int',
        'group_name': 'str',
        'commission_amount': 'str',
        'commission_asset': 'str',
        'source': 'str'
    }

    attribute_map = {
        'commission_time': 'commission_time',
        'user_id': 'user_id',
        'group_name': 'group_name',
        'commission_amount': 'commission_amount',
        'commission_asset': 'commission_asset',
        'source': 'source'
    }

    def __init__(self, commission_time=None, user_id=None, group_name=None, commission_amount=None, commission_asset=None, source=None, local_vars_configuration=None):  # noqa: E501
        # type: (int, int, str, str, str, str, Configuration) -> None
        """AgencyCommission - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._commission_time = None
        self._user_id = None
        self._group_name = None
        self._commission_amount = None
        self._commission_asset = None
        self._source = None
        self.discriminator = None

        if commission_time is not None:
            self.commission_time = commission_time
        if user_id is not None:
            self.user_id = user_id
        if group_name is not None:
            self.group_name = group_name
        if commission_amount is not None:
            self.commission_amount = commission_amount
        if commission_asset is not None:
            self.commission_asset = commission_asset
        if source is not None:
            self.source = source

    @property
    def commission_time(self):
        """Gets the commission_time of this AgencyCommission.  # noqa: E501

        Commission Time. (unix timestamp)  # noqa: E501

        :return: The commission_time of this AgencyCommission.  # noqa: E501
        :rtype: int
        """
        return self._commission_time

    @commission_time.setter
    def commission_time(self, commission_time):
        """Sets the commission_time of this AgencyCommission.

        Commission Time. (unix timestamp)  # noqa: E501

        :param commission_time: The commission_time of this AgencyCommission.  # noqa: E501
        :type: int
        """

        self._commission_time = commission_time

    @property
    def user_id(self):
        """Gets the user_id of this AgencyCommission.  # noqa: E501

        User ID  # noqa: E501

        :return: The user_id of this AgencyCommission.  # noqa: E501
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this AgencyCommission.

        User ID  # noqa: E501

        :param user_id: The user_id of this AgencyCommission.  # noqa: E501
        :type: int
        """

        self._user_id = user_id

    @property
    def group_name(self):
        """Gets the group_name of this AgencyCommission.  # noqa: E501

        Group name  # noqa: E501

        :return: The group_name of this AgencyCommission.  # noqa: E501
        :rtype: str
        """
        return self._group_name

    @group_name.setter
    def group_name(self, group_name):
        """Sets the group_name of this AgencyCommission.

        Group name  # noqa: E501

        :param group_name: The group_name of this AgencyCommission.  # noqa: E501
        :type: str
        """

        self._group_name = group_name

    @property
    def commission_amount(self):
        """Gets the commission_amount of this AgencyCommission.  # noqa: E501

        Commission Amount  # noqa: E501

        :return: The commission_amount of this AgencyCommission.  # noqa: E501
        :rtype: str
        """
        return self._commission_amount

    @commission_amount.setter
    def commission_amount(self, commission_amount):
        """Sets the commission_amount of this AgencyCommission.

        Commission Amount  # noqa: E501

        :param commission_amount: The commission_amount of this AgencyCommission.  # noqa: E501
        :type: str
        """

        self._commission_amount = commission_amount

    @property
    def commission_asset(self):
        """Gets the commission_asset of this AgencyCommission.  # noqa: E501

        Commission Asset  # noqa: E501

        :return: The commission_asset of this AgencyCommission.  # noqa: E501
        :rtype: str
        """
        return self._commission_asset

    @commission_asset.setter
    def commission_asset(self, commission_asset):
        """Sets the commission_asset of this AgencyCommission.

        Commission Asset  # noqa: E501

        :param commission_asset: The commission_asset of this AgencyCommission.  # noqa: E501
        :type: str
        """

        self._commission_asset = commission_asset

    @property
    def source(self):
        """Gets the source of this AgencyCommission.  # noqa: E501

        Source.  SPOT - SPOT Rebate, FUTURES - Futures Rebate  # noqa: E501

        :return: The source of this AgencyCommission.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this AgencyCommission.

        Source.  SPOT - SPOT Rebate, FUTURES - Futures Rebate  # noqa: E501

        :param source: The source of this AgencyCommission.  # noqa: E501
        :type: str
        """

        self._source = source

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AgencyCommission):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AgencyCommission):
            return True

        return self.to_dict() != other.to_dict()
