# coding: utf-8

"""
    Gate API v4

    Welcome to Gate API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.   # noqa: E501

    Contact: support@mail.gate.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class RepayCurrencyRes(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'succeeded': 'bool',
        'label': 'str',
        'message': 'str',
        'currency': 'str',
        'repaid_principal': 'str',
        'repaid_interest': 'str'
    }

    attribute_map = {
        'succeeded': 'succeeded',
        'label': 'label',
        'message': 'message',
        'currency': 'currency',
        'repaid_principal': 'repaid_principal',
        'repaid_interest': 'repaid_interest'
    }

    def __init__(self, succeeded=None, label=None, message=None, currency=None, repaid_principal=None, repaid_interest=None, local_vars_configuration=None):  # noqa: E501
        # type: (bool, str, str, str, str, str, Configuration) -> None
        """RepayCurrencyRes - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._succeeded = None
        self._label = None
        self._message = None
        self._currency = None
        self._repaid_principal = None
        self._repaid_interest = None
        self.discriminator = None

        if succeeded is not None:
            self.succeeded = succeeded
        if label is not None:
            self.label = label
        if message is not None:
            self.message = message
        if currency is not None:
            self.currency = currency
        if repaid_principal is not None:
            self.repaid_principal = repaid_principal
        if repaid_interest is not None:
            self.repaid_interest = repaid_interest

    @property
    def succeeded(self):
        """Gets the succeeded of this RepayCurrencyRes.  # noqa: E501

        Has the repayment been successful  # noqa: E501

        :return: The succeeded of this RepayCurrencyRes.  # noqa: E501
        :rtype: bool
        """
        return self._succeeded

    @succeeded.setter
    def succeeded(self, succeeded):
        """Sets the succeeded of this RepayCurrencyRes.

        Has the repayment been successful  # noqa: E501

        :param succeeded: The succeeded of this RepayCurrencyRes.  # noqa: E501
        :type: bool
        """

        self._succeeded = succeeded

    @property
    def label(self):
        """Gets the label of this RepayCurrencyRes.  # noqa: E501

        Error identifier for unsuccessful operations; empty for successful.  # noqa: E501

        :return: The label of this RepayCurrencyRes.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this RepayCurrencyRes.

        Error identifier for unsuccessful operations; empty for successful.  # noqa: E501

        :param label: The label of this RepayCurrencyRes.  # noqa: E501
        :type: str
        """

        self._label = label

    @property
    def message(self):
        """Gets the message of this RepayCurrencyRes.  # noqa: E501

        Error description in case of operation failure; empty when successful.  # noqa: E501

        :return: The message of this RepayCurrencyRes.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this RepayCurrencyRes.

        Error description in case of operation failure; empty when successful.  # noqa: E501

        :param message: The message of this RepayCurrencyRes.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def currency(self):
        """Gets the currency of this RepayCurrencyRes.  # noqa: E501

        Repayment currency  # noqa: E501

        :return: The currency of this RepayCurrencyRes.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this RepayCurrencyRes.

        Repayment currency  # noqa: E501

        :param currency: The currency of this RepayCurrencyRes.  # noqa: E501
        :type: str
        """

        self._currency = currency

    @property
    def repaid_principal(self):
        """Gets the repaid_principal of this RepayCurrencyRes.  # noqa: E501

        Principal  # noqa: E501

        :return: The repaid_principal of this RepayCurrencyRes.  # noqa: E501
        :rtype: str
        """
        return self._repaid_principal

    @repaid_principal.setter
    def repaid_principal(self, repaid_principal):
        """Sets the repaid_principal of this RepayCurrencyRes.

        Principal  # noqa: E501

        :param repaid_principal: The repaid_principal of this RepayCurrencyRes.  # noqa: E501
        :type: str
        """

        self._repaid_principal = repaid_principal

    @property
    def repaid_interest(self):
        """Gets the repaid_interest of this RepayCurrencyRes.  # noqa: E501

        Principal  # noqa: E501

        :return: The repaid_interest of this RepayCurrencyRes.  # noqa: E501
        :rtype: str
        """
        return self._repaid_interest

    @repaid_interest.setter
    def repaid_interest(self, repaid_interest):
        """Sets the repaid_interest of this RepayCurrencyRes.

        Principal  # noqa: E501

        :param repaid_interest: The repaid_interest of this RepayCurrencyRes.  # noqa: E501
        :type: str
        """

        self._repaid_interest = repaid_interest

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RepayCurrencyRes):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RepayCurrencyRes):
            return True

        return self.to_dict() != other.to_dict()
