# coding: utf-8

"""
    Gate API v4

    Welcome to Gate API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.   # noqa: E501

    Contact: support@mail.gate.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class SavedAddress(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'currency': 'str',
        'chain': 'str',
        'address': 'str',
        'name': 'str',
        'tag': 'str',
        'verified': 'str'
    }

    attribute_map = {
        'currency': 'currency',
        'chain': 'chain',
        'address': 'address',
        'name': 'name',
        'tag': 'tag',
        'verified': 'verified'
    }

    def __init__(self, currency=None, chain=None, address=None, name=None, tag=None, verified=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, str, str, str, str, str, Configuration) -> None
        """SavedAddress - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._currency = None
        self._chain = None
        self._address = None
        self._name = None
        self._tag = None
        self._verified = None
        self.discriminator = None

        if currency is not None:
            self.currency = currency
        if chain is not None:
            self.chain = chain
        if address is not None:
            self.address = address
        if name is not None:
            self.name = name
        if tag is not None:
            self.tag = tag
        if verified is not None:
            self.verified = verified

    @property
    def currency(self):
        """Gets the currency of this SavedAddress.  # noqa: E501

        Currency  # noqa: E501

        :return: The currency of this SavedAddress.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this SavedAddress.

        Currency  # noqa: E501

        :param currency: The currency of this SavedAddress.  # noqa: E501
        :type: str
        """

        self._currency = currency

    @property
    def chain(self):
        """Gets the chain of this SavedAddress.  # noqa: E501

        Chain name  # noqa: E501

        :return: The chain of this SavedAddress.  # noqa: E501
        :rtype: str
        """
        return self._chain

    @chain.setter
    def chain(self, chain):
        """Sets the chain of this SavedAddress.

        Chain name  # noqa: E501

        :param chain: The chain of this SavedAddress.  # noqa: E501
        :type: str
        """

        self._chain = chain

    @property
    def address(self):
        """Gets the address of this SavedAddress.  # noqa: E501

        Address  # noqa: E501

        :return: The address of this SavedAddress.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this SavedAddress.

        Address  # noqa: E501

        :param address: The address of this SavedAddress.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def name(self):
        """Gets the name of this SavedAddress.  # noqa: E501

        Name  # noqa: E501

        :return: The name of this SavedAddress.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SavedAddress.

        Name  # noqa: E501

        :param name: The name of this SavedAddress.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def tag(self):
        """Gets the tag of this SavedAddress.  # noqa: E501

        Tag  # noqa: E501

        :return: The tag of this SavedAddress.  # noqa: E501
        :rtype: str
        """
        return self._tag

    @tag.setter
    def tag(self, tag):
        """Sets the tag of this SavedAddress.

        Tag  # noqa: E501

        :param tag: The tag of this SavedAddress.  # noqa: E501
        :type: str
        """

        self._tag = tag

    @property
    def verified(self):
        """Gets the verified of this SavedAddress.  # noqa: E501

        Whether to pass the verification 0-unverified, 1-verified  # noqa: E501

        :return: The verified of this SavedAddress.  # noqa: E501
        :rtype: str
        """
        return self._verified

    @verified.setter
    def verified(self, verified):
        """Sets the verified of this SavedAddress.

        Whether to pass the verification 0-unverified, 1-verified  # noqa: E501

        :param verified: The verified of this SavedAddress.  # noqa: E501
        :type: str
        """

        self._verified = verified

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SavedAddress):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SavedAddress):
            return True

        return self.to_dict() != other.to_dict()
